#! /bin/bash

#BASE_DIR="/usr/local/samba/var/cache/gpo_cache/"
BASE_DIR="/var/cache/samba/gpo_cache/"
BASE_DIR=`smbd -b | grep CACHEDIR | awk '{print $2}'`
if [ $? != 0 ]; then
	    exit 1
fi
DOMAIN_NAME=`wbinfo --own-domain`
DOMAIN_NAME=$DOMAIN_NAME".COM"
DOMAIN_NAME="$(echo $DOMAIN_NAME | tr '[:upper:]' '[:lower:]')"

if [[ $DOMAIN_NAME == "(null).com" ]]; then
	DOMAIN_NAME=`cat /tmp/current_domain`
fi

#echo $BASE_DIR $DOMAIN_NAME

EXEC_DIRS=`find $BASE_DIR/gpo_cache/$DOMAIN_NAME -name "Shutdown"`
#echo $EXEC_DIRS
#echo $INI_FILE

CMD_ARR=("")
ARG_ARR=("")

read_flag=0
index=0

for EXEC_DIR in $EXEC_DIRS
do
	INI_FILE=${EXEC_DIR%/*}"/scripts.ini"
	dos2unix $INI_FILE
	while read line
	do
		echo $line
		#line=`echo -n $line`
		if [[ $line = "[Startup]" ]];then
			read_flag=0
			echo "startup get "
		fi

		if [[ $line = "[Shutdown]" ]];then
			read_flag=1
			echo "shutdown here"
			continue
		fi
		
		if [ $read_flag -eq 1 ];then
			if [[ $line =~ "CmdLine" ]];then
				CMD_ARR[$index]=$EXEC_DIR/${line#*=}
			elif [[ $line =~ "Parameters" ]];then
				ARG_ARR[$index]=${line#*=}
				let "index=${index}+1"
			fi
		fi
		#echo $index
		echo "------$index"
	done < $INI_FILE
	unix2dos $INI_FILE
done

echo cmds  ${CMD_ARR[@]}
echo args  ${ARG_ARR[@]}

arg_index=0
for script in ${CMD_ARR[@]}
do
	echo file in policy  $script
	dos2unix $script
	if [ -f "$script" ];then
		if [ -x $EXEC_DIR/$script ];then
			echo "exec cmd: $script"
			source $script ${ARG_ARR[arg_index]}
		else 
			echo "add and exec cmd: $script"
			chmod +x $script
			source $script ${ARG_ARR[arg_index]}
		fi
	fi
	let "arg_index=${arg_index}+1"
done
