#! /bin/bash

#init
echo 'init'>/tmp/drives.log

STAGE=`echo $1 | awk -F= '{print $2}'`
if [ "${STAGE}" != "login" ];then
	exit 0
fi

USER_NAME=`echo $3 | awk -F= '{print $2}'`
# echo USER_NAME=$USER_NAME>>/tmp/drives.log

USER_PASSWORD=`echo $4 | awk -F= '{print $2}'`
echo USER_PASSWORD=$USER_PASSWORD>>/tmp/drives.log

DOMAIN_NAME=`wbinfo --own-domain`
USER_HOME_DIR=/home/$DOMAIN_NAME/$USER_NAME

USER=${DOMAIN_NAME}'\'${USER_NAME}
UID=`wbinfo --user-info=${USER} | awk -F: '{print $3}'`
GID=`wbinfo --user-info=${USER} | awk -F: '{print $4}'`
GROUP=`wbinfo --gid-info=${GID} | awk -F: '{print $1}'`

DOMAIN_NAME=$DOMAIN_NAME".COM"
DOMAIN_NAME="$(echo $DOMAIN_NAME | tr '[:upper:]' '[:lower:]')"
POLICY_PATH=$USER_HOME_DIR/.cache/gpo_cache/$DOMAIN_NAME/Policies/
DRIVES_TXT=$USER_HOME_DIR/.cache/.preferences_drives.txt
#VER_PATH=`smbd -b | grep CACHEDIR`
#VER_PATH=$VER_PATH/gpo_cache/$DOMAIN_NAME/Policies/
#echo "ver path :"$VER_PATH
verFn=''
drivesFn=''
drivesBkFn=''
gptFn=''
oldVerNum=0
verNum=0
verNo=-1

# get Version from GPT.INI
# $1: GPT.INI
# output: -1 or Number;

function getVer() 
{
    # verNo=-1;
	echo "fn:"$1>>/tmp/drives.log
  #  cat $1 | while read con
	for con in `cat $1`
    do 
		echo "con: $con">>/tmp/drives.log
        if [[ $con == Version=* ]]; then
         	
            #verNo=`echo $con | grep -o '[0-9]\{1,\}'`
			verNo=${con#*=}
            echo "verNo: "$verNo>>/tmp/drives.log 
       #     return $verNo
            break
        fi
    done

    echo "!!verNo:" $verNo >>/tmp/drives.log 
    return $verNo;
}


# save VerNumber to ver.txt
# $1:Version Number;
# $2:file Name(Ver.txt);
function saveVer()
{
    echo $1>$2
}

# rename from Drives.xml to Drives.xml.bk
# $1: Drives.xml

function mvDrivesBK()
{
  #  local newfile = $1".bk"
    echo "~~~~~mv " $1 $2 >>/tmp/drives.log
    cp $1 $2
    rm $1
    echo $?>>/tmp/drives.log
}


#umount
if [ -e ${DRIVES_TXT} ];then
	for line in `cat ${DRIVES_TXT}`
	do
        echo "umount $line" >>/tmp/drives.log
		umount $line
		rm -rf $line
	done
	rm ${DRIVES_TXT}
fi

echo POLICY_PATH=$POLICY_PATH>>/tmp/drives.log

drivePath=''
#find Preferences/Drives
for line in `find ${POLICY_PATH} -name "Preferences"`
do 
    
	echo "line: "${line}>>/tmp/drives.log
    drivePath=$line/Drives

    echo "drivePath: "${drivePath}>>/tmp/drives.log
    if [ ! -d ${drivePath} ]; then
        echo "path no exists">>/tmp/drives.log
        continue
    fi


    #find ver.txt
    verFn=$drivePath"/ver.txt"
    drivesFn=$drivePath"/Drives.xml"
 	drivesBkFn=$drivePath"/Drives.xml.bk"
	gptFn=$drivePath"/../../../GPT.INI"
	
# no ver.txt
    if [ ! -e ${verFn} ]; then
		if [ ! -e ${drivesFn} ]; then
#no Drives.xml, no policy
			continue 
		else
            getVer $gptFn
            # verNum=$?
			# verNum=$verNo
            echo "get ver:"$verNo "firstly.">>/tmp/drives.log

			if [ $verNo -eq -1]; then

				echo "get version number error of ${gptFn}">>/tmp/drives.log
				continue

			fi
            saveVer $verNo $verFn
            rm ${drivesBkFn}
	#		if [ -e ${drivesBkFn} ]; then
	#			echo "failed to rm.">>/tmp/drives.log
	#		else
	#			echo "suc to rm.">>/tmp/drives.log
	#		fi
	        mvDrivesBK ${drivesFn} ${drivesBkFn}
            #goto parse
		fi

	fi

# check whether the version is updated or not
	oldVerNum=`cat $verFn`
    getVer $gptFn
  #  verNum=$verNo 
    echo "get ver: $oldVerNum--${verNo} secondly.">>/tmp/drives.log
    if [[ $oldVerNum == $verNo ]]; then
		#no change
     	#goto parse
        echo "the same version.">>/tmp/drives.log
	else
		#update
   		if [ -e ${drivesFn} ]; then
		# drives.xml exist.
			echo "update drives.xml.">>/tmp/drives.log
			saveVer $verNo $verFn
	        mvDrivesBK ${drivesFn} ${drivesBkFn}
            #goto parse
		else
			# no drives.xml 
			echo "delete drives.xml.">>/tmp/drives.log
			# rm ver.txt
			rm ${verFn}
			# rm Drives.xml
			rm ${drivesFn}
			# rm Drives.xml.bk
			rm ${drivesBkFn}
		    continue 
		fi
	fi


	#handle bk file
	echo backfile=$drivesBkFn>>/tmp/drives.log
	SRC=''
	DEST=''
    if [ -e ${drivesBkFn} ]; then
		echo "file exists.">>/tmp/drives.log
    else
     	echo "file no exists.">>/tmp/drives.log
	fi

	for prop in `xmllint --xpath "//Properties" $drivesBkFn | awk '{print $0}'`
	do
		# get key
		key=${prop%=*}
        echo key=$key>>/tmp/drives.log

		# get value
		value=${prop#*\"}
        # echo 1value=$kvalue>>/tmp/drives.log

		value=${value%\"*}
        # echo 2value=$kvalue>>/tmp/drives.log

		#get src of mount
		if [ $key = "path" ];then
			SRC=${value}
		fi

        #get dest of mount
		if [ $key = "letter" ];then
			DEST=${value}
		fi

		newprop=${prop/"<Properties"/}
		echo newprop=${newprop}>>/tmp/drives.log
		echo prop=${prop}>>/tmp/drives.log
		if [ "${newprop}" != "${prop}" ];then
			if [ "${SRC}" != "" -a "${DEST}" != "" ];then
				DEST="/mnt/"${DEST}"("${SRC}")"
				echo 0DEST=${DEST}>>/tmp/drives.log
				mkdir ${DEST}
				echo "0mount -t cifs -o username=${USER_NAME},password=${USER_PASSWORD} ${SRC} ${DEST}">>/tmp/drives.log
				mount -t cifs -o username=${USER_NAME},password=${USER_PASSWORD},uid=${UID},gid=${GID} ${SRC} ${DEST}
				echo ${DEST} >> ${DRIVES_TXT}
				SRC=''
				DEST=''
			fi
		fi
	done
	if [ "${SRC}" != "" -a "${DEST}" != "" ];then
		DEST="/mnt/"${DEST}"("${SRC}")"
		echo 1DEST=${DEST}>>/tmp/drives.log
		mkdir ${DEST}
		echo "1mount -t cifs -o username=${USER_NAME},password=${USER_PASSWORD} ${SRC} ${DEST}">>/tmp/drives.log
		mount -t cifs -o username=${USER_NAME},password=${USER_PASSWORD},uid=${UID},gid=${GID} ${SRC} ${DEST}
		echo ${DEST} >> ${DRIVES_TXT}
	fi
 
done


