#! /bin/bash

STAGE=`echo $1 | awk -F= '{print $2}'`
if [ "${STAGE}" != "login" ];then
	exit 0
fi

USER_NAME=`echo $3 | awk -F= '{print $2}'`
USER_PASSWORD=`echo $4 | awk -F= '{print $2}'`

DOMAIN_NAME=`wbinfo --own-domain`
USER_HOME_DIR=/home/$DOMAIN_NAME/$USER_NAME

USER=${DOMAIN_NAME}'\'${USER_NAME}
UserID=`wbinfo --user-info=${USER} | awk -F: '{print $3}'`
GroupID=`wbinfo --user-info=${USER} | awk -F: '{print $4}'`
GROUP=`wbinfo --gid-info=${GroupID} | awk -F: '{print $1}'`

DOMAIN_NAME=$DOMAIN_NAME".COM"
DOMAIN_NAME="$(echo $DOMAIN_NAME | tr '[:upper:]' '[:lower:]')"
POLICY_PATH=$USER_HOME_DIR/.cache/gpo_cache/$DOMAIN_NAME/Policies/

FOLDER_SRC=""

GUID2folder(){
	if [ "$1" = "{B4BFCC3A-DB2C-424C-B029-7FE99A87C641}" ];then
		if [ "${LANGUAGE:0:5}" = "zh_CN" ]; then FOLDER_SRC="桌面"; else FOLDER_SRC="Desktop"; fi
	elif [ "$1" = "{374DE290-123F-4565-9164-39C4925E467B}" ];then
		if [ "${LANGUAGE:0:5}" = "zh_CN" ]; then FOLDER_SRC="下载"; else FOLDER_SRC="Downloads"; fi
	elif [ "$1" = "{FDD39AD0-238F-46AF-ADB4-6C85480369C7}" ];then
		if [ "${LANGUAGE:0:5}" = "zh_CN" ]; then FOLDER_SRC="文档"; else FOLDER_SRC="Documents"; fi
	elif [ "$1" = "{4BD8D571-6D19-48D3-BE97-422220080E43}" ];then
		if [ "${LANGUAGE:0:5}" = "zh_CN" ]; then FOLDER_SRC="音乐"; else FOLDER_SRC="Music"; fi
	elif [ "$1" = "{33E28130-4E1E-4676-835A-98395C3BC3BB}" ];then
		if [ "${LANGUAGE:0:5}" = "zh_CN" ]; then FOLDER_SRC="图片"; else FOLDER_SRC="Pictures"; fi
	elif [ "$1" = "{18989B1D-99B5-455B-841C-AB7C74E4DDFC}" ];then
		if [ "${LANGUAGE:0:5}" = "zh_CN" ]; then FOLDER_SRC="视频"; else FOLDER_SRC="Videos"; fi
	else
		FOLDER_SRC=""
	fi
}

for inifile in `find ${POLICY_PATH} -name 'fdeploy1.ini'| tr " " "\?"`
do
	echo "${inifile}"
	dos2unix "${inifile}"

	# deal with folders that have 'FullPath' attribute
	for line in `awk '/\[Folder_Redirection\]/{flag=1;next}/\[{/{flag=0}flag' "${inifile}"`
	do
		line=${line/"="/"_"}
		line=${line/";"/""}
		folder=${line%_*}
		FOLDER_SRC=""
		GUID2folder "${folder}"
		if [ "${FOLDER_SRC}" = "" ];then continue; fi
		SRC="${USER_HOME_DIR}""/""${FOLDER_SRC}"
		if [ -d  "${SRC}" ];then
			umount "${SRC}" > /dev/null 2>&1
		elif [ -h "${SRC}" ];then
			rm "${SRC}"
			mkdir -p "${SRC}"
		fi
		OLD_IFS="${IFS}"
		IFS=$'\x04'
		fullpath=`awk -F= '/\['"${line}"'/{flag=1;next}/\[{/{flag=0}flag==1&&$1~/FullPath/{print $2;exit}' "${inifile}"`
		if [ "${fullpath}" != "" -a "${fullpath:0:2}" = "\\\\" ];then
			if [ "${fullpath/"%USERNAME%"/""}" != "${fullpath}" ];then
				echo "path has %USERNAME%, ""${fullpath}"
				begin="${fullpath%%"%USERNAME%"*}"
				end="${fullpath##*"%USERNAME%"}"
				end="${USER_NAME}""${end/\\/\/}"
				mount -t cifs -o username="${USER_NAME}",password="${USER_PASSWORD}" "${begin}" "${SRC}"
				mkdir -p "${SRC}""/""${end}"
				umount "${SRC}"
				mount -t cifs -o username="${USER_NAME}",password="${USER_PASSWORD}",uid="${UserID}",gid="${GroupID}" "${begin}""${end}" "${SRC}"
			else
				echo "path does not have %USERNAME%, ""${fullpath}"
				mount -t cifs -o username="${USER_NAME}",password="${USER_PASSWORD}",uid="${UserID}",gid="${GroupID}" "${fullpath}" "${SRC}"
			fi
		fi
		IFS="${OLD_IFS}"
	done

	# deal with folders that have 'ParentFolder' attribute
	for line in `awk '/\[Folder_Redirection\]/{flag=1;next}/\[{/{flag=0}flag' "${inifile}"`
	do
		line=${line/"="/"_"}
		line=${line/";"/""}
		folder=${line%_*}
		FOLDER_SRC=""
		GUID2folder "${folder}"
		if [ "${FOLDER_SRC}" = "" ];then continue; fi
		SRC="${USER_HOME_DIR}""/""${FOLDER_SRC}"
		OLD_IFS="${IFS}"
		IFS=$'\x04'
		parentfolder=`awk -F= '/\['"${line}"'/{flag=1;next}/\[{/{flag=0}flag==1&&$1~/ParentFolder/{print $2;exit}' "${inifile}"`
		relativepath=`awk -F= '/\['"${line}"'/{flag=1;next}/\[{/{flag=0}flag==1&&$1~/RelativePath/{print $2;exit}' "${inifile}"`
		if [ "${parentfolder}" = "{FDD39AD0-238F-46AF-ADB4-6C85480369C7}" ];then
			if [ -d  "${SRC}" ];then
				umount "${SRC}" > /dev/null 2>&1
				rm -rf "${SRC}"
			elif [ -h "${SRC}" ];then
				rm "${SRC}"
			fi
			if [ "${LANGUAGE:0:5}" = "zh_CN" ]; then parentfolder="文档"; else parentfolder="Documents"; fi
			${relativepath:=${FOLDER_SRC}}
			DEST="${USER_HOME_DIR}""/"${parentfolder}"/""${relativepath}"
			mkdir -p "${DEST}"
			ln -s "${DEST}" "${SRC}"
			chown "${USER}":"${GROUP}" "${SRC}"
		fi
		IFS="${OLD_IFS}"
	done
done
