#!/bin/bash

conf_file=/etc/samba/policy.conf/definition.conf
local_pkg_path=/var/lib/samba/self_definition
local_file_ver=$local_pkg_path/definition.version


if [ ! -d $local_pkg_path ];then
    mkdir -p $local_pkg_path
fi

#get username
for param in $@
do
    tmp=${param%%=*}
    if [ "$tmp" = "--username" ];then
        username=${param#*=}
    fi
done

if [ ! -f $conf_file ];then
    echo "$conf_file not found, exit"
    exit
fi

#if there no version number gived,exit
for param in `cat $conf_file`
do
    tmp=${param%%=*}
    if [ "$tmp" = "--VerNum" ];then
	net_ver=${param#*=}
    elif [ "$tmp" = "--PathName" ];then
	pathname=${param#*=}
    elif [ "$tmp" = "--FileName" ];then
	filename=${param#*=}
    fi
done

echo "pathname = $pathname, filename = $filename"

#verify whether net_ver meets the requirements or not
if [ -z "$net_ver" ] || [ -z "$(echo $net_ver | sed -n "/^[0-9]\+$/p")" ];then
    echo "vernum does not meet the requirements,it sould be a number, exit"
    if [ -f $local_file_ver ];then
        rm -rf $local_file_ver
    fi
    exit
fi


#determine if there is a policy update based on the version number
if [ -f $local_file_ver ];then
    local_ver=`cat $local_file_ver`
    echo "local_ver = $local_ver, net_ver = $net_ver"
    if [[ $net_ver = $local_ver ]];then
        echo "***stage1 : there is nothing changed, exit!**"
        exit
    elif [[ $net_ver != $local_ver ]];then
        echo "*****stage1 : something have changed!*******"
        echo $net_ver > $local_file_ver
    fi
else
    echo "****stage1: there no version file, create it!***"
    echo $net_ver > $local_file_ver
fi


cd $pathname

touch $filename

echo "create file successfully!"
