#########################################################################
# File Name: script.sh
# Author: yaozs
# mail: zhisheng@cpu-os.ac.cn
# Created Time: 2017年09月12日 Tue 15时49分27秒
# Modified by YangY
#########################################################################
#!/bin/bash

echo "env">/tmp/env.txt
while true;do
    case $1 in
        --EnableEnv=*)
            enableenv=`echo $1 |awk -F '=' '{print $2}'`
            shift
            ;;
        --PolicyId=*)
            policyid=`echo $1 |awk -F'=' '{print $2}'`			
            shift
            ;;
        --Version=*)
            version=`echo $1 |awk -F '=' '{print $2}'|tr "[:upper:]" "[:lower:]" `
            shift
            ;;
        --ADName=*)
            adname=`echo $1 |awk -F '=' '{print $2}'|tr "[:upper:]" "[:lower:]" `
            shift
            ;;
        --username=*)
            username=`echo $1 |awk -F '=' '{print $2}' `
            shift
            ;;
        *)
            if [ "A" = "A$enableenv" ] || [ "A" = "A$username" ];then
                echo "1:Error Parameter! EnableEnv、username are required! "
                echo "eg: $0 --EnableEnv=0/1/\"**Del.0\"/\"**Del.1\" --PolicyId=\"\{new_path\}\" --ADName=\"test.com\" --username=\"test\""
                exit 1;				
            fi
            if [ "A$enableenv" = "A0" ];then
                if  [ "A" = "A$policyid" ] || [ "A" = "A$adname" ];then
                    echo "2:Error Parameter! EnableEnv、PolicyId、ADName、username are required! "
                    echo "eg: $0 --EnableEnv=0/1/\"**Del.0\"/\"**Del.1\" --PolicyId=\"\{new_path\}\" --ADName=\"test.com\" --username=\"test\""
                    exit 1;
                fi
            fi
            break;
            ;;
    esac
done

echo "EnableEnv:"${enableenv} >>/tmp/env.txt
echo "Version:"${version} >>/tmp/env.txt
echo "policyid:"${policyid} >>/tmp/env.txt

username=`echo $username | sed 's/.COM//ig'`
CACHEDIR="/home/$username/.cache" 
# NEWENVPATH="$CACHEDIR/gpo_cache/$adname/Policies/$policyid/USER/Scripts/Env/newEnv.txt"
#policyid="{"$policyid"}"

#echo `find $CACHEDIR/gpo_cache/$adname/Policies/$policyid -name "newEnv.txt"` >> /tmp/env.txt
#for NEWENVPATH in `find $CACHEDIR/gpo_cache/$adname/Policies/$policyid -name "newEnv.txt"`
#do

#done

CONFIGPATH="/home/$username/.newEnv"
BASHRCPATH="/home/$username/.bashrc"
BASHRCTMPPATH="/home/$username/.bashrc.tmp"

OLDVERSION=`cat $BASHRCPATH| grep ^#policyVersion= | awk -F '=' '{print $2}'`
echo "old ver: " ${OLDVERSION} >>/tmp/env.txt
echo "ver: " ${version} >>/tmp/env.txt
if [ "$OLDVERSION" = "$version" ];then
    echo "Same Policy! Don't excute!">>/tmp/env.txt
    exit 0;
fi

echo "enableenv: " ${enableenv} >>/tmp/env.txt

case $enableenv in
    0)

        for NEWENVPATH in `find $CACHEDIR/gpo_cache/$adname/Policies/$policyid -name "newEnv.txt"`
        do
            echo "NEWENVPATH: " ${NEWENVPATH} >>/tmp/env.txt

            # $BASHRCPATH does exist ?
            if [ ! -f $BASHRCPATH ];then
                echo "create new file: "$BASHRCPATH >>/tmp/env.txt
                touch $BASHRCPATH
            fi

            if [ -f $NEWENVPATH ];then
                # echo "file exists."$NEWENVPATH >>/tmp/env.txt
                cp $NEWENVPATH $CONFIGPATH
                echo `cat $CONFIGPATH` >>/tmp/env.txt
                #cat $BASHRCPATH |grep -v \#policyVersion= > $BASHRCTMPPATH
		sed -i "/#policyVersion=/d" $BASHRCPATH
                #echo "BASHRCTMPPATH: " $BASHRCTMPPATH>>/tmp/env.txt
                echo "delete policyVer.">>/tmp/env.txt
                #echo `cat $BASHRCTMPPATH` >>/tmp/env.txt
                #cat $BASHRCTMPPATH |grep -v "if\ \[ \-f\ $CONFIGPATH\ \]\;then\ \. $CONFIGPATH\;fi" > $BASHRCTMPPATH
                #cat $BASHRCTMPPATH |grep -v "#domaincomment" > $BASHRCTMPPATH
		sed -i "/#domaincomment/d" $BASHRCPATH
                echo "#policyVersion=$version\nif [ -f $CONFIGPATH ];then . $CONFIGPATH;fi #domaincomment" >> $BASHRCPATH
                rm -rf $BASHRCTMPPATH
            else 
                echo "file no exists."$NEWENVPATH >>/tmp/env.txt
            fi
            . $BASHRCPATH

        done

        ;;

    1|**Del.0)


        echo "1 **Del.0 " >>/tmp/env.txt

        cat $BASHRCPATH |grep -v \^\#policyVersion= > $BASHRCTMPPATH

        echo "delete policyVer.">>/tmp/env.txt
                echo `cat $BASHRCTMPPATH` >>/tmp/env.txt

        cat $BASHRCTMPPATH |grep -v "#domaincomment" > $BASHRCPATH

        echo "delete configpath.">>/tmp/env.txt
		echo `cat $BASHRCTMPPATH` >>/tmp/env.txt

        echo "#policyVersion=$version" >> $BASHRCTMPPATH
        #cat $BASHRCTMPPATH > $BASHRCPATH
        rm -rf $BASHRCTMPPATH
        if [ -f $CONFIGPATH ];then
            rm -rf $CONFIGPATH
        fi
        . $BASHRCPATH
        ;;

    **Del.1|**Del.)
        echo "1 **Del.1 " >>/tmp/env.txt

        ;;

    *)

        echo "default " >>/tmp/env.txt
        echo "4:Unkonw EnableEnv! Please make sure! "
        echo "eg: $0 --EnableEnv=0/1/\"**Del.0\"/\"**Del.1\" --PolicyId=\"\{new_path\}\" --ADName=\"test.com\" --username=\"test\""
        exit 1;
        ;;
esac


