#!/bin/bash
BACKUP_DIR="/usr/share/cdos-domain-control-client/backup/"
ARGSFILE="/usr/share/cdos-domain-control-client/backup/args"
DNSFILE="/etc/resolvconf/resolv.conf.d/head"
DEVICE=`nmcli device | grep -v "^vmnet1" | grep -v "vmnet8" | awk '$2~/ethernet/{print}' | awk '{print $1}'`
DEVICETYPE=`nmcli device | grep -v "^vmnet1" | grep -v "vmnet8" | awk '$2~/ethernet/{print}' | awk '{print $2}'`

DOMAIN_STRING=`wbinfo --own-domain | xargs wbinfo --dc-info | awk -F " " '{print $1}'`
DOMAIN_STRING=${DOMAIN_STRING#*.}
DNS_NAME=`wbinfo --own-domain | xargs wbinfo --dc-info | awk -F " " '{print $2}' | awk -F "(" '{print $2}' | awk -F ")" '{print $1}'`
if [ ! -d $BACKUP_DIR ]; then
	mkdir -p $BACKUP_DIR
fi
dnsvalue=`echo $1 |awk -F '=' '{print $2}'`
del="*"
del_result=$(echo $dnsvalue |grep "${del}")

if [ -n "$dnsvalue" ] && [ "$del_result" = "" ];then
	if [ ! -f "$BACKUP_DIR/head" ]; then
		touch $BACKUP_DIR/head
		if [ `grep -c  "^nameserver" $DNSFILE` -gt 0 ]; then
			DNSADDR=`grep  "^nameserver" /etc/resolvconf/resolv.conf.d/head |awk '{print $2}'`
			echo $DNSADDR >> $BACKUP_DIR/head
			dns=`cat $BACKUP_DIR/head`
			for ele in $dns
			do
				if [ "$ele" != "$DNS_NAME" ]; then
					sed -i /$ele/d $DNSFILE
				fi
			done
    		fi
	fi
	if [ -f $ARGSFILE ]; then
		ARGS=`cat $ARGSFILE`
		for dnsaddress in $ARGS
		do
			if [ "$dnsaddress" != "$DNS_NAME" ]; then
				sed -i /$dnsaddress/d $DNSFILE
			fi
		done
		rm $ARGSFILE
		touch $ARGSFILE
	fi
    if [ `grep -c "^iface[ \t]*$DEVICE[ \t]*inet[ \t]*static" /etc/network/interfaces` -gt 0 ]; then
    	if [ `grep -c "^dns-nameserver" /etc/network/interfaces` -gt 0 ]; then
    		sed -i "s/^dns-nameserver/#dns-nameserver/g" /etc/network/interfaces
    		ip addr flush dev $DEVICE
    		systemctl restart networking.service
    	fi
		sleep 1
		for i in $@
		do
			str="="
			result=$(echo $i |grep "${str}")
			if [[ "$result" != "" ]]
			then
				NameServer=`echo $1 |awk -F '=' '{print $2}'`
				regex="\b(25[0-5]|2[0-4][0-9]|1[0-9][0-9]|[1-9][0-9]|[1-9])\.(25[0-5]|2[0-4][0-9]|1[0-9][0-9]|[1-9][0-9]|[0-9])\.(25[0-5]|2[0-4][0-9]|1[0-9][0-9]|[1-9][0-9]|[0-9])\.(25[0-5]|2[0-4][0-9]|1[0-9][0-9]|[1-9][0-9]|[1-9])\b"
				ckStep2=`echo $NameServer | egrep $regex | wc -l`
				if [ $ckStep2 -eq 0 ]; then
					echo "The string $IPADDR is not a correct ipaddr!!!"
				else
					sed -i "$ a nameserver $NameServer" /etc/resolvconf/resolv.conf.d/head
					echo $NameServer >> $ARGSFILE
				fi
			else
				regex="\b(25[0-5]|2[0-4][0-9]|1[0-9][0-9]|[1-9][0-9]|[1-9])\.(25[0-5]|2[0-4][0-9]|1[0-9][0-9]|[1-9][0-9]|[0-9])\.(25[0-5]|2[0-4][0-9]|1[0-9][0-9]|[1-9][0-9]|[0-9])\.(25[0-5]|2[0-4][0-9]|1[0-9][0-9]|[1-9][0-9]|[1-9])\b"
				ckStep2=`echo $i | egrep $regex | wc -l`
				if [ $ckStep2 -eq 0 ]; then
					echo "The string $IPADDR is not a correct ipaddr!!!"
				else
					sed -i "$ a nameserver $i" /etc/resolvconf/resolv.conf.d/head
					echo $i >> $ARGSFILE
				fi
			fi
		done
		if [ -f "/run/NetworkManager/resolv.conf" ];then
			sed -i /nameserver/d /run/NetworkManager/resolv.conf
		fi
		if [ -f "/run/resolvconf/interface/NetworkManager" ]; then
			sed -i /nameserver/d /run/resolvconf/interface/NetworkManager
		fi
		if [ -f "/run/resolvconf/resolv.conf" ]; then
			sed -i /nameserver/d /run/resolvconf/resolv.conf
		fi
		resolvconf -u
	else
		echo "$IFS" | od -t x1
		echo "" | od -t x1
		SAVEIFS=$IFS
		IFS=$(echo -en "\n\b")
		#if [ `grep -c "type=$DEVICETYPE" /etc/NetworkManager/system-connections/` -gt 0 ]; then
		FILENAME=`grep -r "type=$DEVICETYPE" /etc/NetworkManager/system-connections/`
		if [ -n "$FILENAME" ]; then
			name=`echo  ${FILENAME%:*}`
			if [ `grep -A 10 '\[ipv4\]' $name  |grep -B 10 '\[ipv6\]'  |grep -v "[ipv6]" |grep -v "[ipv4]" |grep -v ^$ |grep -c "method=auto"` -gt 0 ]; then
				if [ `grep -A 10 '\[ipv4\]' $name  |grep -B 10 '\[ipv6\]'  |grep -v "[ipv6]" |grep -v "[ipv4]" |grep -v ^$ |grep -c "^ignore-auto-dns=true"` -eq 0 ]; then
					if [ `grep -c "^ignore-auto-dns=true" $name` -gt 0 ]; then
						sed -i /ignore-auto-dns=true/d $name
					fi
					sed -i '/method=auto/i ignore-auto-dns=true' $name
					echo 1 > $BACKUP_DIR/ignore
				fi
			fi

			if [ `grep -c "^dns=" $name` -gt 0 ]; then
				sed -i "s/^dns=/#dns=/g" $name
			fi
			ip addr flush dev $DEVICE
			systemctl restart network-manager.service
			sleep 1
	    fi
		#fi
		IFS=$SAVEIFS
		echo "$IFS" | od -t x1
		IFS=$(echo -en " \n\t")
		for i in $@
		do
			str="="
			result=$(echo $i |grep "${str}")
			if [[ "$result" != "" ]]
			then
				NameServer=`echo $1 |awk -F '=' '{print $2}'`
				regex="\b(25[0-5]|2[0-4][0-9]|1[0-9][0-9]|[1-9][0-9]|[1-9])\.(25[0-5]|2[0-4][0-9]|1[0-9][0-9]|[1-9][0-9]|[0-9])\.(25[0-5]|2[0-4][0-9]|1[0-9][0-9]|[1-9][0-9]|[0-9])\.(25[0-5]|2[0-4][0-9]|1[0-9][0-9]|[1-9][0-9]|[1-9])\b"
				ckStep2=`echo $NameServer | egrep $regex | wc -l`
				if [ $ckStep2 -eq 0 ]; then
					echo "The string $IPADDR is not a correct ipaddr!!!"
				else
					sed -i "$ a nameserver $NameServer" /etc/resolvconf/resolv.conf.d/head
					echo $NameServer >> $ARGSFILE
				fi
			else
				regex="\b(25[0-5]|2[0-4][0-9]|1[0-9][0-9]|[1-9][0-9]|[1-9])\.(25[0-5]|2[0-4][0-9]|1[0-9][0-9]|[1-9][0-9]|[0-9])\.(25[0-5]|2[0-4][0-9]|1[0-9][0-9]|[1-9][0-9]|[0-9])\.(25[0-5]|2[0-4][0-9]|1[0-9][0-9]|[1-9][0-9]|[1-9])\b"
				ckStep2=`echo $i | egrep $regex | wc -l`
				if [ $ckStep2 -eq 0 ]; then
					echo "The string $IPADDR is not a correct ipaddr!!!"
				else
					sed -i "$ a nameserver $i" /etc/resolvconf/resolv.conf.d/head
					echo $i >> $ARGSFILE
				fi
			fi
		done
		if [ -f "/run/NetworkManager/resolv.conf" ];then
			sed -i /nameserver/d /run/NetworkManager/resolv.conf
		fi
		if [ -f "/run/resolvconf/interface/NetworkManager" ]; then
			sed -i /nameserver/d /run/resolvconf/interface/NetworkManager
		fi
		if [ -f "/run/resolvconf/resolv.conf" ]; then
			sed -i /nameserver/d /run/resolvconf/resolv.conf
		fi
		resolvconf -u
	fi
else
    if [ -f $ARGSFILE ]; then
        ARGS=`cat $ARGSFILE`
        for dnsaddress in $ARGS
        do
            if [ "$dnsaddress" != "$DNS_NAME" ]; then
                sed -i /$dnsaddress/d $DNSFILE
            fi
        done
    fi
    if [ -f "$BACKUP_DIR/head" ]; then
    	dns=`cat $BACKUP_DIR/head`
    	for ele in $dns
    	do
    	    if [ "$ele" != "$DNS_NAME" ]; then
            	if [ `grep -c '^nameserver[ \t]*'"$ele"'' /etc/resolvconf/resolv.conf.d/head` -gt 0 ]; then
                    sed -i "$ a nameserver $ele" /etc/resolvconf/resolv.conf.d/head
                fi
    	    fi
    	done
    fi
    if [ `grep -c "^iface[ \t]*$DEVICE[ \t]*inet[ \t]*static" /etc/network/interfaces` -gt 0 ]; then
    	if [ `grep -c "^#dns-nameserver" /etc/network/interfaces` -gt 0 ]; then
    	    sed -i "s/^#dns-nameserver/dns-nameserver/g" /etc/network/interfaces
    	    ip addr flush dev $DEVICE
    	    systemctl restart networking.service
    	fi

    	resolvconf -u
    else
    	echo "$IFS" | od -t x1
    	echo "" | od -t x1
    	SAVEIFS=$IFS
    	IFS=$(echo -en "\n\b")
    	FILENAME=`grep -r "type=$DEVICETYPE" /etc/NetworkManager/system-connections/`
		if [ -n "$FILENAME" ]; then
			name=`echo  ${FILENAME%:*}`
			if [ -f $BACKUP_DIR/ignore ]; then
				ignore_num=`cat $BACKUP_DIR/ignore`;
				rm $BACKUP_DIR/ignore
			else
				ignore_num=0
			fi
			if [ `grep -c "^ignore-auto-dns=true" $name` -gt 0 ] && [ $ignore_num -eq 1 ]; then
				sed -i /ignore-auto-dns=true/d $name
			fi
			if [ `grep -c "^#dns=" $name` -gt 0 ]; then
				sed -i "s/^#dns=/dns=/g" $name
			fi
			ip addr flush dev $DEVICE
			systemctl restart network-manager.service
		fi
		resolvconf -u
		IFS=$SAVEIFS
		echo "$IFS" | od -t x1
		IFS=$(echo -en " \n\t")
		echo "$IFS" | od -t x1
	fi
	if [ -f $BACKUP_DIR/head ];then
		rm $BACKUP_DIR/head
	fi
    if [ -f $ARGSFILE ]; then
        rm $ARGSFILE
    fi
fi
